package conversions

import data.{Cons, LispList, Nil}

import scala.annotation.tailrec

/**
  * Implicit conversions for LispList.
  */
package object lisplist {

  implicit def lispListToList[A](lispList: LispList[A]): List[A] = {
    @tailrec
    def go(acc: List[A], l: LispList[A]): List[A] =
      l match {
        case Cons(car, cdr) => go(car +: acc, cdr)
        case Nil            => acc
      }
    go(List(), lispList).reverse
  }
}
