/**
  * DO NOT MODIFY THIS FILE. All exercises are performed using implicits only.
  */
package data

/**
  * Superposition is an analogue to Scala's Either and a special case of a
  * Product (any type of A × B) where only A or B exists, but must be treated
  * specially as though it could be either one but not both.
  */
sealed trait Superposition[+A, +B] {

  def downside: A

  def upside: B
}

/**
  * Implied negative case of the Superposition. This is probably not the one you
  * want.
  */
case class Downside[+A, +B](downside: A) extends Superposition[A, B] {

  def upside = throw new Exception("I got the downside!")
}

/**
  * Implied positive case of the Superposition. This is usually the one you want.
  */
case class Upside[+A, +B](upside: B) extends Superposition[A, B] {

  def downside = throw new Exception("I got the upside!")
}
