/**
  * DO NOT MODIFY THIS FILE. All exercises are performed using implicits only.
  */
package object data {

  /**
    * A structure for any type S for which a function exists that derives from
    * S a product of a value of itself and a value of type A. This can model
    * stateful computation where state S is given to a function which produces
    * a potentially-changed state and the result of the computation.
    *
    * @tparam S The state type
    * @tparam A The type returned by the operation
    */
  type State[S, +A] = S => (S, A)

  /**
    * A special case of any type A that is simply itself.
    */
  type Identity[+A] = A
}
