package typeclasses

/**
  * Defines the Applicative operations for any type of kind F[_]. Applicative
  * is a special case of Functor that can apply a function lifted into F[_] to
  * a value also lifted into F[_].
  */
trait Applicative[F[_]] extends Functor[F] {

  /**
    * Lift a value into F[_].
    */
  def pure[A](a: A): F[A] = ???

  /**
    * Lift a value into F[_] and apply it to a lifted function.
    */
  def ap[A, B](ff: F[A => B])(fa: F[A]): F[B]

  /**
    * This can be defined in terms of ap and pure alone, try it out!
    */
  override def map[A, B](fa: F[A])(f: A => B): F[B] = ???
}
