package typeclasses

/**
  * A Monoid is a special case of a Semigroup for which an element of A, when
  * applied to any other element of A in any order, returns that other element.
  * It forms an identity value with which its application merely returns the
  * identity of its associated operand, similar in concept to the identity
  * function.
  */
trait Monoid[A] extends Semigroup[A] {

  /**
    * The identity of A.
    */
  def empty: A
}
