package typeclasses

/**
  * A semigroup is a special case of a binary operation that is both associative
  * and for any two A the operation returns another member of A. In a sense, the
  * Semigroup operation can be used from any two starting members of A to produce
  * all successive members of A.
  */
trait Semigroup[A] {

  /**
    * Binary, associative operation against two of A to produce another A.
    */
  def <>(x: A, b: A): A
}
